; Ŀ
;                                                                          
;   Programname    :  DetectFm.ASM                                         
;   Titel	        :  Detect and Identify Yamaha OPL2 and OPL3 Soundchips  
;   Authors        :  SUBMiSSiVE                                           
;   Organisation   :  The $eeN                                             
;   Version/Date   :  1.0 / 24.10.1994                                     
;   Version/Date   :  1.1 / 07.01.1997 Now a .COM-File                     
;   Language       :  Turbo Assembler 3.2 / TLink 5.1                      
;                                                                          
; 


.Model tiny, pascal ; Use Pascal calling-conventions
.286
jumps
smart
ideal

CodeSeg

org 100h
        ; Program begins here!

         STARTUPCODE
         push offset welcome
         call biosprint
         push 388h
         call DetectAdlib
         test al, 1
         jz m1
         push 388h
         call writeOplType
         push offset fm388msg
         call biosprint
m1:
         push 228h
         call DetectAdlib
         test al, 1
         jz m2
         push 228h
         call writeOplType
         push offset fm228msg
         call biosprint
m2:
         push 248h
         call DetectAdlib
         test al, 1
         jz m3
         push 248h
         call writeOplType
         push offset fm248msg
         call biosprint
m3:
         EXITCODE 0
         ret

DATASEG

	; All possible messages. Please leave my name in the code

welcome  db "Yamaha Soundchip Identify. Written by SUBMiSSiVE (SeeN) (CIS:100121,2450)",13,10
         db "Note: If you have a GUS this program will not work!",13,10,13,10,"$"
opl2msg  db "Generic OPL2 (11 voices mono )at adress $"
opl3msg  db "Generic OPL3 (22 voices stereo) at adress $"
fm388msg db "0388h detected",13,10,"$"
fm228msg db "0220h detected",13,10,"$"
fm248msg db "0240h detected",13,10,"$"

CodeSeg

Proc WritePort near Portnummer:Byte, wert:Byte, Portadr:Word
;
; Write Byte in WERT into OPL-Port Portnummer at Adress PortAdr
        push 	dx ax cx
        mov 	dx, [PortAdr]
        mov 	al, [Portnummer]
        out 	dx, al

        mov cx, 7
warte1:
        in 	al, dx			; Wait here
        dec cx
        jnz warte1

        mov     al, [wert]
        mov 	dx, [PortAdr]
        inc     dx
        out 	dx, al
        mov 	dx, [PortAdr]
        mov     cx, 36
warte2:
        in 	al, dx			; Wait here
        dec cx
        jnz warte2
        pop 	cx ax dx
        ret
EndP WritePort

Proc DetectAdlib near portadr:word
;
; Tryes to detect a OPL-Chip at the given adress. Returns 1 in AL if
; successful, 0 otherwise

local    detect1:byte, detect2:byte

         Push 4             ; Reset both timers
         Push 60h
         push [portadr]
         call WritePort

         Push 4             ; Enable Interrupts
         Push 80h
         push [portadr]
         call Writeport

         mov dx, [portadr]   ; Read Statusport
         in al, dx
         mov [detect1], al

         push 2               ; Set Timer 1
         push 0ffh
         push [portadr]
         call writeport

         push 4               ; Start Timer 1
         push 021h
         push [portadr]
         call writeport


         mov cx, 130          ; Wait
warteschleife:
         in al, dx
         dec cx
         jnz warteschleife
         mov [detect2], al

         Push 4             ; Reset both timers
         Push 60h
         push [portadr]
         call WritePort

         Push 4             ; Enable Interrupts
         Push 80h
         push [portadr]
         call Writeport

         mov al, [detect1]
         and al, 0e0h
         jnz noadlib

         mov al, [detect2]
         and al, 0e0h
         cmp al, 0c0h
         jne noadlib
         ; Adlib detected
         mov ax, 1
         ret
noadlib: mov ax, 0
         ret
endp DetectAdlib

proc BiosPrint near msg:word
;
; Write a message through dos-interrupt
      mov ah, 9
      mov dx, [msg]
      int 021h
      ret
Endp

Proc WriteOplType  p:word
;
; decide between opl2 and opl3 at adress p and write messages
         mov dx, [p]
         in al, dx
         and al, 0ffh
         jz opl3
         push offset opl2msg
         call biosprint
         jmp ende
opl3:
         push offset opl3msg
         call biosprint
ende:    ret
EndP

END
